#define min(a,b) (((a)<(b))?(a):(b))	
#define max(a,b) (((a)>(b))?(a):(b))

#define PI 3.14159265	
#define ROTATION_VEL (250)
//#define FORWARD_VEL (150) this is now a variable
#define LOCATION_TOLERANCE (160)
#define RIGHT (0)
#define LEFT (1)
#define GYRO_PORT (23)
#define LSB_US_PER_DEG  (1400000)
#define encoder() (encoder_read(24))
#define ENC_TO_VPS (23.9879)
#define KP (10)
#define KI (0)
#define KD (-.5)

#define ROT_MIN_SPEED (140)
#define ROT_FACTOR (8)
#define VPS_HEIGHT (258)
#define ROBOT_HEIGHT (21) 
//#define CORRECTION_SIZE (200)
#define CIRCLE_RADIUS (875)
#define TIME_TO_DUMP (100000)
#define CRITICAL_DISTANCE (500)

int8_t alwaysOne;
int8_t goingTo; //0: nothing special, 1: gearbox, 2: mine, 3: dump, 4: middlePoint
int16_t ForwardVel;
uint16_t enc, encDistance, encRunning;
int8_t motorDirection;
int8_t isExploring = 0, dumped = 0;
int8_t team, assumeArrival = 1, startRegion;
uint32_t start_time;

extern volatile uint8_t robot_id;

void startScrolling()
{
	motor_set_vel(4,((team==0)?1:-1)*255);
	motor_set_vel(5,((team==0)?1:-1)*255);
}

void stopScrolling()
{
	/*for(int8_t i=255; i>0; i-=10) {
		motor_set_vel(4, i);
		motor_set_vel(5, i);
		pause(10);
	}*/
	
	motor_set_vel(4, 0);
	motor_set_vel(5, 0);
}

void motorRight(int16_t speed) {
	motor_set_vel(0, speed);
	motor_set_vel(1, speed);
}

void motorLeft(int16_t speed)  {
	motor_set_vel(2, speed);
	motor_set_vel(3, speed);
}

float deg_mod(float n)
{
	float ret = fmod(n,360);
	return (ret<0)?(ret+360.0):ret;
}

float gyro_deg_mod()
{
	return deg_mod(gyro_get_degrees());
}

float getAngle(float a, float b) //returns the angle traveled going from angle a to angle b (with direction)
{
	float ret = b-a;
	if(a>b) {
		if(360.0-a+b < fabs(ret)) ret = 360.0-a+b;
	} else if(a+360.0-b < ret) ret = -(a+360.0-b);
	
	return ret;
}

int8_t signOf(float n) {
	if (n==0) return 0;
	return (n>0)?1:-1;
}

//getRegionDis() assumes that all of the three variables are different
int8_t getRegionDis(int8_t start, int8_t end, int8_t obstacle) 
{
	if(start > end) {
		if(obstacle > start || obstacle < end) 
			return start - end;
		else return 6-start+end;	
	}
	else {
		if(obstacle > end || obstacle < start)
			return end-start;
		else return 6-end+start;
	}
}

float getFarther(float num)
{
	if(num > 0) return ceil(num);
	else return floor(num);
}

float convertVPSAngleToDegees(int VPSangle)
{
	if(VPSangle < 0) return 180.0*VPSangle/2048.0+360.0;
	else return 180.0*VPSangle/2048.0;
}

uint16_t reabExternalFrob(uint16_t min, uint16_t max) {
    uint16_t range = max-min+1;
    return (uint16_t) (((uint32_t)analog_read(21)*range)/1023 + min);
}
