
#include <joyos.h>
#include <lib/pid.h>

#define FORWARD_VEL 230

int16_t limitVel(float vel){
  if (vel < -255) return -255;
  if (vel > 255) return 255;
  return (int16_t)vel;
}

void setVelocities(float correctionAmount){
  motor_set_vel(0, -limitVel(FORWARD_VEL - correctionAmount));
  motor_set_vel(1, -limitVel(FORWARD_VEL + correctionAmount));
}


int umain(){
  struct pid_controller headingPID;

  init_pid( &headingPID,40,  0,  -0.5, &gyro_get_degrees,  &setVelocities);

  headingPID.goal = 0;
  headingPID.enabled = true;
  uint32_t lasttime=get_time();
  int tt=0,t1=0,t2=0,t3=0,t4=0;
  while (true){
	 /* if (frob_read_range(0,1)==1) 
	  if (tt==1) goto aa;
	  if (t1==0) {if ((get_time()-lasttime)>400) {gyro_set_degrees(10);printf("10\n");t1=1;}}
	  if (t2==0) {if ((get_time()-lasttime)>550) {gyro_set_degrees(20);printf("20\n");t2=1;}}
	  if (t3==0) {if ((get_time()-lasttime)>600) {gyro_set_degrees(30);printf("30\n");t3=1;}}
	  if (t4==0)  {if ((get_time()-lasttime)>800) {gyro_set_degrees(45);printf("45\n");tt=1;t4=1;}}

		//	  gyro_set_degrees(5);  lasttime=get_time();
		  //gyro_set_degrees(20);
	aa:
	printf("%f.2   -   %ld \n", gyro_get_degrees(),(uint32_t)(get_time()-lasttime));
	*/
   update_pid(&headingPID);

  }
  return 0;
}

int usetup(){
  gyro_init (23, 1400000, 2000L);
  return 0;
}
